// /model/ArrowdbAcl.js
 

var Client = require('../client');


var ArrowdbAcl = function ArrowdbAcl() {
};

/**
 * This method is used to deserialize API responses that return this type.
 *
 * @param {object} object The response JSON object from an API call
 * @return {ArrowdbAcl} A constructed model from the response.
 */
ArrowdbAcl.constructFromObject = function (object) {
	if (!object) {
		return null; // TODO Throw error?
	}

	var created = new ArrowdbAcl();
	if (object['name']) {
		created['name'] = object['name'];
	}

	if (object['readers']) {
		created['readers'] = object['readers'];
	}

	if (object['writers']) {
		created['writers'] = object['writers'];
	}

	if (object['public_read']) {
		created['public_read'] = object['public_read'];
	}

	if (object['public_write']) {
		created['public_write'] = object['public_write'];
	}

	if (object['user']) {
		created['user'] = object['user'];
	}

	if (object['created_at']) {
		created['created_at'] = object['created_at'];
	}

	if (object['updated_at']) {
		created['updated_at'] = object['updated_at'];
	}

	if (object['pretty_json']) {
		created['pretty_json'] = object['pretty_json'];
	}

	if (object['custom_fields']) {
		created['custom_fields'] = object['custom_fields'];
	}

	if (object['user_id']) {
		created['user_id'] = object['user_id'];
	}

	return created;
};


var p = ArrowdbAcl.prototype;
Object.defineProperty(p, 'name', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_name']; },
	/**
	 * set 
	 * @param {String} name
	 **/
	set: function(val) { this['_name'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'readers', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_readers']; },
	/**
	 * set 
	 * @param {Object} readers
	 **/
	set: function(val) { this['_readers'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'writers', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_writers']; },
	/**
	 * set 
	 * @param {Object} writers
	 **/
	set: function(val) { this['_writers'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'public_read', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_public_read']; },
	/**
	 * set 
	 * @param {String} public_read
	 **/
	set: function(val) { this['_public_read'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'public_write', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_public_write']; },
	/**
	 * set 
	 * @param {String} public_write
	 **/
	set: function(val) { this['_public_write'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'user', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_user']; },
	/**
	 * set 
	 * @param {Object} user
	 **/
	set: function(val) { this['_user'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'created_at', {
	/**
	 * get 
	 * @return {Date}
	 **/
	get: function() { return this['_created_at']; },
	/**
	 * set 
	 * @param {Date} created_at
	 **/
	set: function(val) { this['_created_at'] = Client.convertToType(val, 'Date'); }
});

Object.defineProperty(p, 'updated_at', {
	/**
	 * get 
	 * @return {Date}
	 **/
	get: function() { return this['_updated_at']; },
	/**
	 * set 
	 * @param {Date} updated_at
	 **/
	set: function(val) { this['_updated_at'] = Client.convertToType(val, 'Date'); }
});

Object.defineProperty(p, 'pretty_json', {
	/**
	 * get 
	 * @return {Boolean}
	 **/
	get: function() { return this['_pretty_json']; },
	/**
	 * set 
	 * @param {Boolean} pretty_json
	 **/
	set: function(val) { this['_pretty_json'] = Client.convertToType(val, 'Boolean'); }
});

Object.defineProperty(p, 'custom_fields', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_custom_fields']; },
	/**
	 * set 
	 * @param {String} custom_fields
	 **/
	set: function(val) { this['_custom_fields'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'user_id', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_user_id']; },
	/**
	 * set 
	 * @param {String} user_id
	 **/
	set: function(val) { this['_user_id'] = Client.convertToType(val, 'String'); }
});

module.exports = ArrowdbAcl;
