// /model/ArrowdbFile.js
 

var Client = require('../client');


var ArrowdbFile = function ArrowdbFile() {
};

/**
 * This method is used to deserialize API responses that return this type.
 *
 * @param {object} object The response JSON object from an API call
 * @return {ArrowdbFile} A constructed model from the response.
 */
ArrowdbFile.constructFromObject = function (object) {
	if (!object) {
		return null; // TODO Throw error?
	}

	var created = new ArrowdbFile();
	if (object['name']) {
		created['name'] = object['name'];
	}

	if (object['file']) {
		created['file'] = object['file'];
	}

	if (object['processed']) {
		created['processed'] = object['processed'];
	}

	if (object['url']) {
		created['url'] = object['url'];
	}

	if (object['created_at']) {
		created['created_at'] = object['created_at'];
	}

	if (object['updated_at']) {
		created['updated_at'] = object['updated_at'];
	}

	if (object['user']) {
		created['user'] = object['user'];
	}

	if (object['custom_fields']) {
		created['custom_fields'] = object['custom_fields'];
	}

	if (object['user_id']) {
		created['user_id'] = object['user_id'];
	}

	return created;
};


var p = ArrowdbFile.prototype;
Object.defineProperty(p, 'name', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_name']; },
	/**
	 * set 
	 * @param {String} name
	 **/
	set: function(val) { this['_name'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'file', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_file']; },
	/**
	 * set 
	 * @param {String} file
	 **/
	set: function(val) { this['_file'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'processed', {
	/**
	 * get 
	 * @return {Boolean}
	 **/
	get: function() { return this['_processed']; },
	/**
	 * set 
	 * @param {Boolean} processed
	 **/
	set: function(val) { this['_processed'] = Client.convertToType(val, 'Boolean'); }
});

Object.defineProperty(p, 'url', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_url']; },
	/**
	 * set 
	 * @param {String} url
	 **/
	set: function(val) { this['_url'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'created_at', {
	/**
	 * get 
	 * @return {Date}
	 **/
	get: function() { return this['_created_at']; },
	/**
	 * set 
	 * @param {Date} created_at
	 **/
	set: function(val) { this['_created_at'] = Client.convertToType(val, 'Date'); }
});

Object.defineProperty(p, 'updated_at', {
	/**
	 * get 
	 * @return {Date}
	 **/
	get: function() { return this['_updated_at']; },
	/**
	 * set 
	 * @param {Date} updated_at
	 **/
	set: function(val) { this['_updated_at'] = Client.convertToType(val, 'Date'); }
});

Object.defineProperty(p, 'user', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_user']; },
	/**
	 * set 
	 * @param {Object} user
	 **/
	set: function(val) { this['_user'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'custom_fields', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_custom_fields']; },
	/**
	 * set 
	 * @param {String} custom_fields
	 **/
	set: function(val) { this['_custom_fields'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'user_id', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_user_id']; },
	/**
	 * set 
	 * @param {String} user_id
	 **/
	set: function(val) { this['_user_id'] = Client.convertToType(val, 'String'); }
});

module.exports = ArrowdbFile;
