// /model/ArrowdbKeyValue.js
 

var Client = require('../client');


var ArrowdbKeyValue = function ArrowdbKeyValue() {
};

/**
 * This method is used to deserialize API responses that return this type.
 *
 * @param {object} object The response JSON object from an API call
 * @return {ArrowdbKeyValue} A constructed model from the response.
 */
ArrowdbKeyValue.constructFromObject = function (object) {
	if (!object) {
		return null; // TODO Throw error?
	}

	var created = new ArrowdbKeyValue();
	if (object['name']) {
		created['name'] = object['name'];
	}

	if (object['type']) {
		created['type'] = object['type'];
	}

	if (object['value']) {
		created['value'] = object['value'];
	}

	if (object['custom_fields']) {
		created['custom_fields'] = object['custom_fields'];
	}

	if (object['user_id']) {
		created['user_id'] = object['user_id'];
	}

	return created;
};


var p = ArrowdbKeyValue.prototype;
Object.defineProperty(p, 'name', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_name']; },
	/**
	 * set 
	 * @param {String} name
	 **/
	set: function(val) { this['_name'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'type', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_type']; },
	/**
	 * set 
	 * @param {String} type
	 **/
	set: function(val) { this['_type'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'value', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_value']; },
	/**
	 * set 
	 * @param {String} value
	 **/
	set: function(val) { this['_value'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'custom_fields', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_custom_fields']; },
	/**
	 * set 
	 * @param {String} custom_fields
	 **/
	set: function(val) { this['_custom_fields'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'user_id', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_user_id']; },
	/**
	 * set 
	 * @param {String} user_id
	 **/
	set: function(val) { this['_user_id'] = Client.convertToType(val, 'String'); }
});

module.exports = ArrowdbKeyValue;
