// /model/ArrowdbPhoto.js
 

var Client = require('../client');


var ArrowdbPhoto = function ArrowdbPhoto() {
};

/**
 * This method is used to deserialize API responses that return this type.
 *
 * @param {object} object The response JSON object from an API call
 * @return {ArrowdbPhoto} A constructed model from the response.
 */
ArrowdbPhoto.constructFromObject = function (object) {
	if (!object) {
		return null; // TODO Throw error?
	}

	var created = new ArrowdbPhoto();
	if (object['filename']) {
		created['filename'] = object['filename'];
	}

	if (object['photo']) {
		created['photo'] = object['photo'];
	}

	if (object['title']) {
		created['title'] = object['title'];
	}

	if (object['size']) {
		created['size'] = object['size'];
	}

	if (object['collections']) {
		created['collections'] = object['collections'];
	}

	if (object['md5']) {
		created['md5'] = object['md5'];
	}

	if (object['processed']) {
		created['processed'] = object['processed'];
	}

	if (object['content_type']) {
		created['content_type'] = object['content_type'];
	}

	if (object['urls']) {
		created['urls'] = object['urls'];
	}

	if (object['created_at']) {
		created['created_at'] = object['created_at'];
	}

	if (object['updated_at']) {
		created['updated_at'] = object['updated_at'];
	}

	if (object['tags']) {
		created['tags'] = object['tags'];
	}

	if (object['custom_fields']) {
		created['custom_fields'] = object['custom_fields'];
	}

	if (object['acls']) {
		created['acls'] = object['acls'];
	}

	if (object['user']) {
		created['user'] = object['user'];
	}

	if (object['user_id']) {
		created['user_id'] = object['user_id'];
	}

	if (object['reviews']) {
		created['reviews'] = object['reviews'];
	}

	if (object['reviews_count']) {
		created['reviews_count'] = object['reviews_count'];
	}

	if (object['ratings_count']) {
		created['ratings_count'] = object['ratings_count'];
	}

	if (object['ratings_average']) {
		created['ratings_average'] = object['ratings_average'];
	}

	if (object['ratings_summary']) {
		created['ratings_summary'] = object['ratings_summary'];
	}

	if (object['photo_sizes']) {
		created['photo_sizes'] = object['photo_sizes'];
	}

	if (object['photo_sync_sizes[]']) {
		created['photo_sync_sizes[]'] = object['photo_sync_sizes[]'];
	}

	return created;
};


var p = ArrowdbPhoto.prototype;
Object.defineProperty(p, 'filename', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_filename']; },
	/**
	 * set 
	 * @param {String} filename
	 **/
	set: function(val) { this['_filename'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'photo', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_photo']; },
	/**
	 * set 
	 * @param {String} photo
	 **/
	set: function(val) { this['_photo'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'title', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_title']; },
	/**
	 * set 
	 * @param {String} title
	 **/
	set: function(val) { this['_title'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'size', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_size']; },
	/**
	 * set 
	 * @param {Integer} size
	 **/
	set: function(val) { this['_size'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'collections', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_collections']; },
	/**
	 * set 
	 * @param {Object} collections
	 **/
	set: function(val) { this['_collections'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'md5', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_md5']; },
	/**
	 * set 
	 * @param {String} md5
	 **/
	set: function(val) { this['_md5'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'processed', {
	/**
	 * get 
	 * @return {Boolean}
	 **/
	get: function() { return this['_processed']; },
	/**
	 * set 
	 * @param {Boolean} processed
	 **/
	set: function(val) { this['_processed'] = Client.convertToType(val, 'Boolean'); }
});

Object.defineProperty(p, 'content_type', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_content_type']; },
	/**
	 * set 
	 * @param {String} content_type
	 **/
	set: function(val) { this['_content_type'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'urls', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_urls']; },
	/**
	 * set 
	 * @param {String} urls
	 **/
	set: function(val) { this['_urls'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'created_at', {
	/**
	 * get 
	 * @return {Date}
	 **/
	get: function() { return this['_created_at']; },
	/**
	 * set 
	 * @param {Date} created_at
	 **/
	set: function(val) { this['_created_at'] = Client.convertToType(val, 'Date'); }
});

Object.defineProperty(p, 'updated_at', {
	/**
	 * get 
	 * @return {Date}
	 **/
	get: function() { return this['_updated_at']; },
	/**
	 * set 
	 * @param {Date} updated_at
	 **/
	set: function(val) { this['_updated_at'] = Client.convertToType(val, 'Date'); }
});

Object.defineProperty(p, 'tags', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_tags']; },
	/**
	 * set 
	 * @param {Object} tags
	 **/
	set: function(val) { this['_tags'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'custom_fields', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_custom_fields']; },
	/**
	 * set 
	 * @param {String} custom_fields
	 **/
	set: function(val) { this['_custom_fields'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'acls', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_acls']; },
	/**
	 * set 
	 * @param {String} acls
	 **/
	set: function(val) { this['_acls'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'user', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_user']; },
	/**
	 * set 
	 * @param {Object} user
	 **/
	set: function(val) { this['_user'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'user_id', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_user_id']; },
	/**
	 * set 
	 * @param {String} user_id
	 **/
	set: function(val) { this['_user_id'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'reviews', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_reviews']; },
	/**
	 * set 
	 * @param {Object} reviews
	 **/
	set: function(val) { this['_reviews'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'reviews_count', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_reviews_count']; },
	/**
	 * set 
	 * @param {Integer} reviews_count
	 **/
	set: function(val) { this['_reviews_count'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'ratings_count', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_ratings_count']; },
	/**
	 * set 
	 * @param {Integer} ratings_count
	 **/
	set: function(val) { this['_ratings_count'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'ratings_average', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_ratings_average']; },
	/**
	 * set 
	 * @param {Integer} ratings_average
	 **/
	set: function(val) { this['_ratings_average'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'ratings_summary', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_ratings_summary']; },
	/**
	 * set 
	 * @param {String} ratings_summary
	 **/
	set: function(val) { this['_ratings_summary'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'photo_sizes', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_photo_sizes']; },
	/**
	 * set 
	 * @param {String} photo_sizes
	 **/
	set: function(val) { this['_photo_sizes'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'photo_sync_sizes[]', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_photo_sync_sizes[]']; },
	/**
	 * set 
	 * @param {String} photo_sync_sizes[]
	 **/
	set: function(val) { this['_photo_sync_sizes[]'] = Client.convertToType(val, 'String'); }
});

module.exports = ArrowdbPhoto;
