// /model/ArrowdbPlace.js
 

var Client = require('../client');


var ArrowdbPlace = function ArrowdbPlace() {
};

/**
 * This method is used to deserialize API responses that return this type.
 *
 * @param {object} object The response JSON object from an API call
 * @return {ArrowdbPlace} A constructed model from the response.
 */
ArrowdbPlace.constructFromObject = function (object) {
	if (!object) {
		return null; // TODO Throw error?
	}

	var created = new ArrowdbPlace();
	if (object['name']) {
		created['name'] = object['name'];
	}

	if (object['address']) {
		created['address'] = object['address'];
	}

	if (object['city']) {
		created['city'] = object['city'];
	}

	if (object['state']) {
		created['state'] = object['state'];
	}

	if (object['postal_code']) {
		created['postal_code'] = object['postal_code'];
	}

	if (object['country']) {
		created['country'] = object['country'];
	}

	if (object['latitude']) {
		created['latitude'] = object['latitude'];
	}

	if (object['longitude']) {
		created['longitude'] = object['longitude'];
	}

	if (object['website']) {
		created['website'] = object['website'];
	}

	if (object['twitter']) {
		created['twitter'] = object['twitter'];
	}

	if (object['phone_number']) {
		created['phone_number'] = object['phone_number'];
	}

	if (object['photo']) {
		created['photo'] = object['photo'];
	}

	if (object['tags']) {
		created['tags'] = object['tags'];
	}

	if (object['custom_fields']) {
		created['custom_fields'] = object['custom_fields'];
	}

	if (object['acls']) {
		created['acls'] = object['acls'];
	}

	if (object['user']) {
		created['user'] = object['user'];
	}

	if (object['reviews']) {
		created['reviews'] = object['reviews'];
	}

	if (object['reviews_count']) {
		created['reviews_count'] = object['reviews_count'];
	}

	if (object['ratings_count']) {
		created['ratings_count'] = object['ratings_count'];
	}

	if (object['ratings_average']) {
		created['ratings_average'] = object['ratings_average'];
	}

	if (object['ratings_summary']) {
		created['ratings_summary'] = object['ratings_summary'];
	}

	if (object['user_id']) {
		created['user_id'] = object['user_id'];
	}

	return created;
};


var p = ArrowdbPlace.prototype;
Object.defineProperty(p, 'name', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_name']; },
	/**
	 * set 
	 * @param {String} name
	 **/
	set: function(val) { this['_name'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'address', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_address']; },
	/**
	 * set 
	 * @param {String} address
	 **/
	set: function(val) { this['_address'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'city', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_city']; },
	/**
	 * set 
	 * @param {String} city
	 **/
	set: function(val) { this['_city'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'state', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_state']; },
	/**
	 * set 
	 * @param {String} state
	 **/
	set: function(val) { this['_state'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'postal_code', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_postal_code']; },
	/**
	 * set 
	 * @param {String} postal_code
	 **/
	set: function(val) { this['_postal_code'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'country', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_country']; },
	/**
	 * set 
	 * @param {String} country
	 **/
	set: function(val) { this['_country'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'latitude', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_latitude']; },
	/**
	 * set 
	 * @param {Integer} latitude
	 **/
	set: function(val) { this['_latitude'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'longitude', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_longitude']; },
	/**
	 * set 
	 * @param {Integer} longitude
	 **/
	set: function(val) { this['_longitude'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'website', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_website']; },
	/**
	 * set 
	 * @param {String} website
	 **/
	set: function(val) { this['_website'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'twitter', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_twitter']; },
	/**
	 * set 
	 * @param {String} twitter
	 **/
	set: function(val) { this['_twitter'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'phone_number', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_phone_number']; },
	/**
	 * set 
	 * @param {String} phone_number
	 **/
	set: function(val) { this['_phone_number'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'photo', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_photo']; },
	/**
	 * set 
	 * @param {Object} photo
	 **/
	set: function(val) { this['_photo'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'tags', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_tags']; },
	/**
	 * set 
	 * @param {Object} tags
	 **/
	set: function(val) { this['_tags'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'custom_fields', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_custom_fields']; },
	/**
	 * set 
	 * @param {String} custom_fields
	 **/
	set: function(val) { this['_custom_fields'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'acls', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_acls']; },
	/**
	 * set 
	 * @param {Object} acls
	 **/
	set: function(val) { this['_acls'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'user', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_user']; },
	/**
	 * set 
	 * @param {Object} user
	 **/
	set: function(val) { this['_user'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'reviews', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_reviews']; },
	/**
	 * set 
	 * @param {Object} reviews
	 **/
	set: function(val) { this['_reviews'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'reviews_count', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_reviews_count']; },
	/**
	 * set 
	 * @param {Integer} reviews_count
	 **/
	set: function(val) { this['_reviews_count'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'ratings_count', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_ratings_count']; },
	/**
	 * set 
	 * @param {Integer} ratings_count
	 **/
	set: function(val) { this['_ratings_count'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'ratings_average', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_ratings_average']; },
	/**
	 * set 
	 * @param {Integer} ratings_average
	 **/
	set: function(val) { this['_ratings_average'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'ratings_summary', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_ratings_summary']; },
	/**
	 * set 
	 * @param {String} ratings_summary
	 **/
	set: function(val) { this['_ratings_summary'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'user_id', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_user_id']; },
	/**
	 * set 
	 * @param {String} user_id
	 **/
	set: function(val) { this['_user_id'] = Client.convertToType(val, 'String'); }
});

module.exports = ArrowdbPlace;
