// /model/ArrowdbUser.js
 

var Client = require('../client');


var ArrowdbUser = function ArrowdbUser() {
};

/**
 * This method is used to deserialize API responses that return this type.
 *
 * @param {object} object The response JSON object from an API call
 * @return {ArrowdbUser} A constructed model from the response.
 */
ArrowdbUser.constructFromObject = function (object) {
	if (!object) {
		return null; // TODO Throw error?
	}

	var created = new ArrowdbUser();
	if (object['email']) {
		created['email'] = object['email'];
	}

	if (object['username']) {
		created['username'] = object['username'];
	}

	if (object['first_name']) {
		created['first_name'] = object['first_name'];
	}

	if (object['last_name']) {
		created['last_name'] = object['last_name'];
	}

	if (object['role']) {
		created['role'] = object['role'];
	}

	if (object['admin']) {
		created['admin'] = object['admin'];
	}

	if (object['external_accounts']) {
		created['external_accounts'] = object['external_accounts'];
	}

	if (object['photo']) {
		created['photo'] = object['photo'];
	}

	if (object['created_at']) {
		created['created_at'] = object['created_at'];
	}

	if (object['updated_at']) {
		created['updated_at'] = object['updated_at'];
	}

	if (object['friend_counts']) {
		created['friend_counts'] = object['friend_counts'];
	}

	if (object['custom_fields']) {
		created['custom_fields'] = object['custom_fields'];
	}

	if (object['user_id']) {
		created['user_id'] = object['user_id'];
	}

	if (object['password']) {
		created['password'] = object['password'];
	}

	if (object['password_confirmation']) {
		created['password_confirmation'] = object['password_confirmation'];
	}

	return created;
};


var p = ArrowdbUser.prototype;
Object.defineProperty(p, 'email', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_email']; },
	/**
	 * set 
	 * @param {String} email
	 **/
	set: function(val) { this['_email'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'username', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_username']; },
	/**
	 * set 
	 * @param {String} username
	 **/
	set: function(val) { this['_username'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'first_name', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_first_name']; },
	/**
	 * set 
	 * @param {String} first_name
	 **/
	set: function(val) { this['_first_name'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'last_name', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_last_name']; },
	/**
	 * set 
	 * @param {String} last_name
	 **/
	set: function(val) { this['_last_name'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'role', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_role']; },
	/**
	 * set 
	 * @param {String} role
	 **/
	set: function(val) { this['_role'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'admin', {
	/**
	 * get 
	 * @return {Boolean}
	 **/
	get: function() { return this['_admin']; },
	/**
	 * set 
	 * @param {Boolean} admin
	 **/
	set: function(val) { this['_admin'] = Client.convertToType(val, 'Boolean'); }
});

Object.defineProperty(p, 'external_accounts', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_external_accounts']; },
	/**
	 * set 
	 * @param {Object} external_accounts
	 **/
	set: function(val) { this['_external_accounts'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'photo', {
	/**
	 * get 
	 * @return {Object}
	 **/
	get: function() { return this['_photo']; },
	/**
	 * set 
	 * @param {Object} photo
	 **/
	set: function(val) { this['_photo'] = Client.convertToType(val, Object); }
});

Object.defineProperty(p, 'created_at', {
	/**
	 * get 
	 * @return {Date}
	 **/
	get: function() { return this['_created_at']; },
	/**
	 * set 
	 * @param {Date} created_at
	 **/
	set: function(val) { this['_created_at'] = Client.convertToType(val, 'Date'); }
});

Object.defineProperty(p, 'updated_at', {
	/**
	 * get 
	 * @return {Date}
	 **/
	get: function() { return this['_updated_at']; },
	/**
	 * set 
	 * @param {Date} updated_at
	 **/
	set: function(val) { this['_updated_at'] = Client.convertToType(val, 'Date'); }
});

Object.defineProperty(p, 'friend_counts', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_friend_counts']; },
	/**
	 * set 
	 * @param {String} friend_counts
	 **/
	set: function(val) { this['_friend_counts'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'custom_fields', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_custom_fields']; },
	/**
	 * set 
	 * @param {String} custom_fields
	 **/
	set: function(val) { this['_custom_fields'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'user_id', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_user_id']; },
	/**
	 * set 
	 * @param {String} user_id
	 **/
	set: function(val) { this['_user_id'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'password', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_password']; },
	/**
	 * set 
	 * @param {String} password
	 **/
	set: function(val) { this['_password'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'password_confirmation', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_password_confirmation']; },
	/**
	 * set 
	 * @param {String} password_confirmation
	 **/
	set: function(val) { this['_password_confirmation'] = Client.convertToType(val, 'String'); }
});

module.exports = ArrowdbUser;
