// /model/Car.js
 

var Client = require('../client');


var Car = function Car() {
};

/**
 * This method is used to deserialize API responses that return this type.
 *
 * @param {object} object The response JSON object from an API call
 * @return {Car} A constructed model from the response.
 */
Car.constructFromObject = function (object) {
	if (!object) {
		return null; // TODO Throw error?
	}

	var created = new Car();
	if (object['make']) {
		created['make'] = object['make'];
	}

	if (object['model']) {
		created['model'] = object['model'];
	}

	if (object['year']) {
		created['year'] = object['year'];
	}

	if (object['bluebook']) {
		created['bluebook'] = object['bluebook'];
	}

	if (object['mileage']) {
		created['mileage'] = object['mileage'];
	}

	return created;
};


var p = Car.prototype;
Object.defineProperty(p, 'make', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_make']; },
	/**
	 * set 
	 * @param {String} make
	 **/
	set: function(val) { this['_make'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'model', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_model']; },
	/**
	 * set 
	 * @param {String} model
	 **/
	set: function(val) { this['_model'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'year', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_year']; },
	/**
	 * set 
	 * @param {Integer} year
	 **/
	set: function(val) { this['_year'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'bluebook', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_bluebook']; },
	/**
	 * set 
	 * @param {Integer} bluebook
	 **/
	set: function(val) { this['_bluebook'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'mileage', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_mileage']; },
	/**
	 * set 
	 * @param {Integer} mileage
	 **/
	set: function(val) { this['_mileage'] = Client.convertToType(val, 'Integer'); }
});

module.exports = Car;
