// /model/ResponseModel.js
 

var Client = require('../client');


var ResponseModel = function ResponseModel() {
};

/**
 * This method is used to deserialize API responses that return this type.
 *
 * @param {object} object The response JSON object from an API call
 * @return {ResponseModel} A constructed model from the response.
 */
ResponseModel.constructFromObject = function (object) {
	if (!object) {
		return null; // TODO Throw error?
	}

	var created = new ResponseModel();
	if (object['code']) {
		created['code'] = object['code'];
	}

	if (object['success']) {
		created['success'] = object['success'];
	}

	if (object['request-id']) {
		created['request-id'] = object['request-id'];
	}

	if (object['message']) {
		created['message'] = object['message'];
	}

	if (object['url']) {
		created['url'] = object['url'];
	}

	return created;
};


var p = ResponseModel.prototype;
Object.defineProperty(p, 'code', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_code']; },
	/**
	 * set 
	 * @param {Integer} code
	 **/
	set: function(val) { this['_code'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'success', {
	/**
	 * get 
	 * @return {Boolean}
	 **/
	get: function() { return this['_success']; },
	/**
	 * set 
	 * @param {Boolean} success
	 **/
	set: function(val) { this['_success'] = Client.convertToType(val, 'Boolean'); }
});

Object.defineProperty(p, 'request-id', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_request-id']; },
	/**
	 * set 
	 * @param {String} request-id
	 **/
	set: function(val) { this['_request-id'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'message', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_message']; },
	/**
	 * set 
	 * @param {String} message
	 **/
	set: function(val) { this['_message'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'url', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_url']; },
	/**
	 * set 
	 * @param {String} url
	 **/
	set: function(val) { this['_url'] = Client.convertToType(val, 'String'); }
});

module.exports = ResponseModel;
