// /model/Student.js
 

var Client = require('../client');


var Student = function Student() {
};

/**
 * This method is used to deserialize API responses that return this type.
 *
 * @param {object} object The response JSON object from an API call
 * @return {Student} A constructed model from the response.
 */
Student.constructFromObject = function (object) {
	if (!object) {
		return null; // TODO Throw error?
	}

	var created = new Student();
	if (object['fName']) {
		created['fName'] = object['fName'];
	}

	if (object['lName']) {
		created['lName'] = object['lName'];
	}

	if (object['Class']) {
		created['Class'] = object['Class'];
	}

	if (object['year']) {
		created['year'] = object['year'];
	}

	if (object['StudentID']) {
		created['StudentID'] = object['StudentID'];
	}

	if (object['TeacherName']) {
		created['TeacherName'] = object['TeacherName'];
	}

	return created;
};


var p = Student.prototype;
Object.defineProperty(p, 'fName', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_fName']; },
	/**
	 * set 
	 * @param {String} fName
	 **/
	set: function(val) { this['_fName'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'lName', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_lName']; },
	/**
	 * set 
	 * @param {String} lName
	 **/
	set: function(val) { this['_lName'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'Class', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_Class']; },
	/**
	 * set 
	 * @param {String} Class
	 **/
	set: function(val) { this['_Class'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'year', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_year']; },
	/**
	 * set 
	 * @param {Integer} year
	 **/
	set: function(val) { this['_year'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'StudentID', {
	/**
	 * get 
	 * @return {Integer}
	 **/
	get: function() { return this['_StudentID']; },
	/**
	 * set 
	 * @param {Integer} StudentID
	 **/
	set: function(val) { this['_StudentID'] = Client.convertToType(val, 'Integer'); }
});

Object.defineProperty(p, 'TeacherName', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_TeacherName']; },
	/**
	 * set 
	 * @param {String} TeacherName
	 **/
	set: function(val) { this['_TeacherName'] = Client.convertToType(val, 'String'); }
});

module.exports = Student;
