// /model/Testuser.js
 

var Client = require('../client');


var Testuser = function Testuser() {
};

/**
 * This method is used to deserialize API responses that return this type.
 *
 * @param {object} object The response JSON object from an API call
 * @return {Testuser} A constructed model from the response.
 */
Testuser.constructFromObject = function (object) {
	if (!object) {
		return null; // TODO Throw error?
	}

	var created = new Testuser();
	if (object['first_name']) {
		created['first_name'] = object['first_name'];
	}

	if (object['last_name']) {
		created['last_name'] = object['last_name'];
	}

	if (object['email']) {
		created['email'] = object['email'];
	}

	return created;
};


var p = Testuser.prototype;
Object.defineProperty(p, 'first_name', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_first_name']; },
	/**
	 * set 
	 * @param {String} first_name
	 **/
	set: function(val) { this['_first_name'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'last_name', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_last_name']; },
	/**
	 * set 
	 * @param {String} last_name
	 **/
	set: function(val) { this['_last_name'] = Client.convertToType(val, 'String'); }
});

Object.defineProperty(p, 'email', {
	/**
	 * get 
	 * @return {String}
	 **/
	get: function() { return this['_email']; },
	/**
	 * set 
	 * @param {String} email
	 **/
	set: function(val) { this['_email'] = Client.convertToType(val, 'String'); }
});

module.exports = Testuser;
